Index: trunk/BNS/bnshelp.html
===================================================================
--- trunk/BNS/bnshelp.html	(revision 1693)
+++ trunk/BNS/bnshelp.html	(revision 1694)
@@ -78,8 +78,8 @@
 <p><a name="resources"><h3>3. Modes & Resources</h3></p>
 <p>
-Apart from its regular window mode, BNS can be run as a background job in a 'no window' mode using processing options from previously saved configuration.
-</p>
-<p>
-BNS requires access to the Internet with a minimum of about 1 kbits/sec per stream depending on the stream format and the number of visible satellites. You need to make sure that the connection can sustain the required bandwidth.
+Apart from its regular window mode, BNS can be run as a background job in a 'no window' mode using processing options from a previously saved configuration.
+</p>
+<p>
+BNS requires access to the Internet with a minimum of about 1 kbits/sec per stream depending on the number of GNSS systems. You need to make sure that the connection can sustain the required bandwidth.
 </p>
 <p>
@@ -94,5 +94,5 @@
 
 <p>
-The usual handling of BNS is that you first select severs for 'RINEX Ephemeris' and 'Clocks & Orbits'. You then select an NTRIP broadcaster for stream upload ('Broadcast Corrections') before you start the program ('Start'). Records of BNS's activities are shown in the'Logs' canvas in the middle of the main window.
+The usual handling of BNS is that you first select severs for 'RINEX Ephemeris' and 'Clocks & Orbits'. You then select an NTRIP broadcaster for stream upload ('Broadcast Corrections') before you start the program ('Start'). Records of BNS's activities are shown in the 'Logs' canvas in the middle of the main window.
 </p>
 
@@ -125,4 +125,5 @@
 &nbsp; &nbsp; &nbsp; 4.6.3. <a href=#ephcsys>System</a><br>
 &nbsp; &nbsp; &nbsp; 4.6.4. <a href=#ephcsave>Save</a><br>
+&nbsp; &nbsp; &nbsp; 4.6.5. <a href=#ephbec>Broadcast Clocks</a><br>
 4.7. <a href=#clkrnx>RINEX Clocks</a><br>
 &nbsp; &nbsp; &nbsp; 4.7.1. <a href=#clkdir>Directory</a><br>
@@ -408,4 +409,9 @@
 </p>
 
+<p><a name="ephbec"><h4>4.6.5 Broadcast Clocks - optional</h4></p>
+<p>
+Tick 'Broadcast clocks" to ignore incoming clock estimates and send broadcast clocks instead of broadcast clock corrections.</p><p>This option is implemented to enable comparison with IGS post processing products. For that these clocks will not be corrected for the 2nd order relativistic effect.
+</p>
+
 <p><a name="clkrnx"><h4>4.7. RINEX Clocks</h4></p>
 <p>
@@ -454,10 +460,10 @@
 <p><a name="bottom"><h4>4.9. Bottom Menu Bar</h4></p>
 <p>
-The bottom menu bar allows to start or stop the execution of BNS and provides access the BNC's online help funtion.
+The bottom menu bar allows to start or stop the execution of BNS and provides access to BNC's online help funtion.
 </p>
 
 <p><a name="start"><h4>4.9.1 Start</h4></p>
 <p>
-Hit 'Start' to start receiving IGS orbits and clocks and convert them into corrections to Broadcast Ephemeris. Note that when started BNS by default will begin with new files which might overwrite existing files when necessary unless the option 'Append files' is ticked.
+Hit 'Start' to start receiving IGS orbits and clocks and convert them into corrections to Broadcast Ephemeris. Note that when started, BNS by default will begin with new files which might overwrite existing files when necessary unless the option 'Append files' is ticked.
 </p> 
 
@@ -474,5 +480,5 @@
 <p><a name="nw"><h4>4.10.1 No Window - optional</h4></p>
 <p>
-Apart from its regular windows mode, BNS can be started on all systems as a background/batch job with command line option '-nw'. BNS will then run in 'no window' mode, using processing options from its configuration file on disk. Terminate BNS using Windows Task Manager when running it in 'no window' mode on Windows systems.
+Apart from its regular windows mode, BNS can be started on all systems as a background job with command line option '-nw'. BNS will then run in 'no window' mode, using processing options from its configuration file on disk. Terminate BNS using Windows Task Manager when running it in 'no window' mode on Windows systems.
 </p>
 <p>
@@ -581,4 +587,8 @@
 <li>Enables streaming over mobile IP networks because of using TCP/IP.</li>
 </ul>
+</p>
+
+<p>
+The NTRIP Version 2 transport protocol is not implemented in BNS.
 </p>
 