Index: trunk/BNS/bnshelp.html
===================================================================
--- trunk/BNS/bnshelp.html	(revision 1694)
+++ trunk/BNS/bnshelp.html	(revision 1695)
@@ -630,22 +630,24 @@
 <tr><td>logFile=/home/weber/rinex/bns.log</td><td>General: Logfile (full path)</td></tr>
 <tr><td>fileAppend=0</td><td>General: Append files</td></tr>
-<tr><td>font="Helvetica [Adobe],8,-1,5,75,0,0,0,0,0"</td><td>Internal memory: Used font</td></tr>
-<tr><td>refSys_1=IGS05</td><td>Broadcast Corrections I: System</td></tr>
-<tr><td>refSys_2=ETRF2000</td><td>Broadcast Corrections II: System</td></tr>
-<tr><td>inpEcho=/home/weber/rinex/ClocksOrbits.dat</td><td>Clocks & Orbits: Save (full path)</td></tr>
+<tr><td>autoStart=0</td><td>General: Auto start</td></tr>
 <tr><td>ephHost=clock-ip.bkg.bund.de</td><td>RINEX Ephemeris: Host</td></tr>
 <tr><td>ephPort=6000</td><td>RINEX Ephemeris: Port</td></tr>
 <tr><td>ephEcho=/home/weber/rinex/eph.rnx</td><td>RINEX Ephemeris: Save (full path)</td></tr>
 <tr><td>clkPort=7000</td><td>Clocks & Orbits: Listening port</td></tr>
+<tr><td>inpEcho=/home/weber/rinex/ClocksOrbits.dat</td><td>Clocks & Orbits: Save (full path)</td></tr>
 <tr><td>outHost1=www.igs-ip.net</td><td>Broadcast Corrections I: Host</td></tr>
 <tr><td>outPort1=2101</td><td>Broadcast Corrections I: Port</td></tr>
-<tr><td>outHost2=www.euref-ip.net</td><td>Broadcast Corrections II: Host</td></tr>
+<tr><td>mountpoint_1=CLCK1</td><td>Broadcast Corrections I: Mountpoint</td></tr>
+<tr><td>password1=pw</td><td>Broadcast Corrections I: Password</td></tr>
+<tr><td>refSys_1=IGS05</td><td>Broadcast Corrections I: System</td></tr>
+<tr><td>outFile_1=/home/weber/rinex/CLCK1</td><td>Broadcast Corrections I: Save (full path)</td></tr>
+<tr><td>beClocks1=0</td><td>Broadcast Corrections I: Broadcast clocks</td></tr>
+<tr><td>outHost2=www.igs-.net</td><td>Broadcast Corrections II: Host</td></tr>
 <tr><td>outPort2=2101</td><td>Broadcast Corrections II: Port</td></tr>
-<tr><td>mountpoint_1=CLCK1</td><td>Broadcast Corrections I: Mountpoint</td></tr>
 <tr><td>mountpoint_2=CLCK2</td><td>Broadcast Corrections II: Mountpoint</td></tr>
-<tr><td>outFile_1=/home/weber/rinex/CLCK1</td><td>Broadcast Corrections I: Save (full path)</td></tr>
+<tr><td>password2=pw</td><td>Broadcast Corrections II: Password</td></tr>
+<tr><td>refSys_2=ETRF2000</td><td>Broadcast Corrections II: System</td></tr>
 <tr><td>outFile_2=/home/weber/rinex/CLCK2</td><td>Broadcast Corrections II: Save (full path)</td></tr>
-<tr><td>password1=pw1</td><td>Broadcast Corrections I: Password</td></tr>
-<tr><td>password2=pw2</td><td>Broadcast Corrections I: Password</td></tr>
+<tr><td>beClocks2=0</td><td>Broadcast Corrections II: Broadcast clocks</td></tr>
 <tr><td>rnxPath=/home/weber/rinex</td><td>RINEX Clocks: Directory</td></tr>
 <tr><td>rnxIntr=1 day</td><td>RINEX Clocks: Interval</td></tr>
@@ -655,7 +657,5 @@
 <tr><td>sp3Sampl=300</td><td>SP3 Orbits: Sampling</td></tr>
 <tr><td>startTab=0</td><td>Internal memory: Top tab</td></tr>
-<tr><td>autoStart=0</td><td>General: Auto start</td></tr>
-<tr><td>beClocks1=0</td><td>Broadcast Corrections I: Broadcast clocks</td></tr>
-<tr><td>beClocks2=0</td><td>Broadcast Corrections I: Broadcast clocks</td></tr>
+<tr><td>font="Helvetica [Adobe],8,-1,5,75,0,0,0,0,0"</td><td>Internal memory: Used font</td></tr>
 </table>
 
Index: trunk/BNS/bnssettings.cpp
===================================================================
--- trunk/BNS/bnssettings.cpp	(revision 1694)
+++ trunk/BNS/bnssettings.cpp	(revision 1695)
@@ -27,22 +27,25 @@
     setValue("proxyPort",   "");
     setValue("logFile",     "");
+    setValue("autoStart",   "0");
     setValue("fileAppend",  "0");
-    setValue("refSys_1",    "IGS05");
-    setValue("refSys_2",    "IGS05");
-    setValue("inpEcho",     "");
     setValue("ephHost",     "");
     setValue("ephPort",     "");
     setValue("ephEcho",     "");
     setValue("clkPort",     "");
+    setValue("inpEcho",     "");
     setValue("outHost1",    "");
     setValue("outPort1",    "");
+    setValue("mountpoint_1","");
+    setValue("password1",   "");
+    setValue("refSys_1",    "IGS05");
+    setValue("outFile_1",   "");
+    setValue("beClocks1",   "0");
     setValue("outHost2",    "");
     setValue("outPort2",    "");
-    setValue("mountpoint_1","");
     setValue("mountpoint_2","");
-    setValue("outFile_1",   "");
+    setValue("password2",   "");
+    setValue("refSys_2",    "IGS05");
     setValue("outFile_2",   "");
-    setValue("password1",   "");
-    setValue("password2",   "");
+    setValue("beClocks2",   "0");
     setValue("rnxPath",     "");
     setValue("rnxIntr",     "1 min");
@@ -52,7 +55,4 @@
     setValue("sp3Sampl",    "0");
     setValue("startTab",    "0");
-    setValue("autoStart",   "0");
-    setValue("beClocks1",   "0");
-    setValue("beClocks2",   "0");
     sync();
   }