Index: /trunk/BNC/bnchelp.html
===================================================================
--- /trunk/BNC/bnchelp.html	(revision 1745)
+++ /trunk/BNC/bnchelp.html	(revision 1746)
@@ -36,4 +36,5 @@
 <li>retrieve real-time GNSS data streams available through NTRIP transport protocol,</li>
 <li>retrieve real-time GNSS data streams via TCP directly from an IP address without using the NTRIP transport protocol, and/or</li>
+<li>retrieve real-time GNSS data streams from a serial port without using the NTRIP transport protocol, and/or</li>
 <li>generate high-rate RINEX Observation and Navigation files to support near real-time GNSS post-processing applications, and/or</li> 
 <li>generate ephemeris and synchronized or unsynchronized observations epoch by epoch through an IP port to support real-time GNSS network engines, and/or</li> 
@@ -42,5 +43,5 @@
 <li>monitor the performance of a network of real-time GNSS data streams to generate advisory notes, and/or</li>
 <li>scan RTCM streams for incoming antenna information as well as message types and their repetition rates, and/or</li>
-<li>feed a stream into a GNSS rover via serial communication link.</li>
+<li>feed a stream into a GNSS receiver via serial communication link.</li>
 </ul>
 </p>
@@ -116,14 +117,15 @@
 &nbsp; &nbsp; &nbsp; 3.7.4. <a href=#syncfile>File</a><br>
 &nbsp; &nbsp; &nbsp; 3.7.5. <a href=#syncuport>Port (unsynchronized)</a><br>
-3.8. <a href=#serial>Serial Link</a><br>
+3.8. <a href=#serial>Serial Output</a><br>
 &nbsp; &nbsp; &nbsp; 3.8.1. <a href=#sermount>Mountpoint</a><br>
 &nbsp; &nbsp; &nbsp; 3.8.2. <a href=#serport>Port Name</a><br>
 &nbsp; &nbsp; &nbsp; 3.8.3. <a href=#serbaud>Baud Rate</a><br>
-&nbsp; &nbsp; &nbsp; 3.8.4. <a href=#serparity>Parity</a><br>
-&nbsp; &nbsp; &nbsp; 3.8.5. <a href=#serdata>Data Bits</a><br>
-&nbsp; &nbsp; &nbsp; 3.8.6. <a href=#serstop>Stop Bits</a><br>
-&nbsp; &nbsp; &nbsp; 3.8.7. <a href=#serauto>NMEA</a><br>
-&nbsp; &nbsp; &nbsp; 3.8.8. <a href=#serfile>File</a><br>
-&nbsp; &nbsp; &nbsp; 3.8.9. <a href=#serheight>Height</a><br>
+&nbsp; &nbsp; &nbsp; 3.8.4. <a href=#serflow>Flow Control</a><br>
+&nbsp; &nbsp; &nbsp; 3.8.5. <a href=#serparity>Parity</a><br>
+&nbsp; &nbsp; &nbsp; 3.8.6. <a href=#serdata>Data Bits</a><br>
+&nbsp; &nbsp; &nbsp; 3.8.7. <a href=#serstop>Stop Bits</a><br>
+&nbsp; &nbsp; &nbsp; 3.8.8. <a href=#serauto>NMEA</a><br>
+&nbsp; &nbsp; &nbsp; 3.8.9. <a href=#serfile>File</a><br>
+&nbsp; &nbsp; &nbsp; 3.8.10. <a href=#serheight>Height</a><br>
 3.9. <a href=#advnote>Outages</a><br>
 &nbsp; &nbsp; &nbsp; 3.9.1. <a href=#obsrate>Observation Rate</a><br>
@@ -147,6 +149,7 @@
 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 3.12.1.5 <a href=#ntripv>NTRIP Version</a><br>
 &nbsp; &nbsp; &nbsp; 3.12.2 <a href=#streamip>Add Streams - Coming from TCP/IP Port</a><br>
-&nbsp; &nbsp; &nbsp; 3.12.3 <a href=#start>Start</a><br>
-&nbsp; &nbsp; &nbsp; 3.12.4 <a href=#stop>Stop</a><br>
+&nbsp; &nbsp; &nbsp; 3.12.3 <a href=#streamser>Add Streams - Coming from Serial Port</a><br>
+&nbsp; &nbsp; &nbsp; 3.12.4 <a href=#start>Start</a><br>
+&nbsp; &nbsp; &nbsp; 3.12.5 <a href=#stop>Stop</a><br>
 3.13. <a href=#cmd>Command Line Options</a><br>
 &nbsp; &nbsp; &nbsp; 3.13.1. <a href=#nw>No Window Mode</a><br>
@@ -572,20 +575,20 @@
 <p>
 
-<p><a name="serial"><h4>3.8. Serial Link</h4></p>
-<p>
-You may use BNC to feed a serial connected device like an GNSS rover. For that one of the incoming streams can be forwarded to a serial port.
+<p><a name="serial"><h4>3.8. Serial Output</h4></p>
+<p>
+You may use BNC to feed a serial connected device like an GNSS receiver. For that one of the incoming streams can be forwarded to a serial port.
 </p>
 
 <p><a name="sermount"><h4>3.8.1 Mountpoint - optional</h4></p>
 <p>
-Enter a 'Mountpoint' to forward its corresponding stream to a serial connected device.
-</p>
-<p>
-When selecting the serial communication options listed below, make sure that you pick those configured to the serial connected device.
+Enter a 'Mountpoint' to forward its corresponding stream to a serial connected GNSS receiver.
+</p>
+<p>
+When selecting the serial communication options listed below, make sure that you pick those configured to the serial connected receiver.
 </p>
 
 <p><a name="serport"><h4>3.8.2 Port Name - mandatory if 'Mountpoint' is set</h4></p>
 <p>
-Enter the serial 'Port name' selected on your host for communication with the serial connected device. Valid port names are
+Enter the serial 'Port name' selected on your host for communication with the serial connected receiver. Valid port names are
 </p>
 <pre>
@@ -604,37 +607,42 @@
 <p><a name="serbaud"><h4>3.8.3 Baud Rate - mandatory if 'Mountpoint' is set</h4></p>
 <p>
-Select a 'Baud rate' for the serial link. Note that using a high baud rate is recommended.
-</p>
-
-<p><a name="serparity"><h4>3.8.4 Parity - mandatory if 'Mountpoint' is set</h4></p>
-<p>
-Select the 'Parity' for the serial link. Note that parity is often set to 'NONE'.
-</p>
-
-<p><a name="serdata"><h4>3.8.5 Data Bits - mandatory if 'Mountpoint' is set</h4></p>
-<p>
-Select the number of 'Data bits' for the serial link. Note that often '8' data bits are used.
-</p>
-
-<p><a name="serstop"><h4>3.8.6 Stop Bits - mandatory if 'Mountpoint' is set</h4></p>
-<p>
-Select the number of 'Stop bits' for the serial link. Note that often '1' stop bit is used.
-</p>
-
-<p><a name="serauto"><h4>3.8.7 NMEA - mandatory for VRS streams</h4></p>
-<p>
-Select 'Auto' to automatically forward all NMEA-GGA messages coming from your serial connected device to the NTRIP broadcaster and/or save them in a file.
-</p>
-<p>
-Forwarding valid NMEA-GGA messages to the NTRIP broadcaster is required for receiving 'Virtual Reference Station' (VRS) streams. Thus, in case your serial connected device is not capable to provide them, the alternative for VRS streams is a 'Manual' simulation of an initial NMEA-GGA message. Its contents is based on the approximate (editable) latitude/longitude from the broadcaster's source-table and an approximate VRS height to be specified.
-</p>
-<p>
-In summary: select 'Manual' only when handling a VRS stream and your serial connected device doesn't generate NMEA-GGA messages. Otherwise select 'Auto'.
-</p>
-
-<p><a name="serfile"><h4>3.8.8 File - optional if 'Auto' NMEA is set</h4></p>
-<p>Specify the full path to a file where NMEA messages coming from your serial connected device are saved.
-</p>
-<p><a name="serheight"><h4>3.8.9 Height - mandatory if 'Manual' NMEA is set</h4></p>
+Select a 'Baud rate' for the serial output link. Note that using a high baud rate is recommended.
+</p>
+
+<p><a name="serflow"><h4>3.8.4 Flow Control - mandatory if 'Mountpoint' is set</h4></p>
+<p>
+Select a 'Flow control' for the serial output link. Note that your selection must equal the flow control configured to the serial connected device. Select 'OFF' if you don't know better.
+</p>
+
+<p><a name="serparity"><h4>3.8.5 Parity - mandatory if 'Mountpoint' is set</h4></p>
+<p>
+Select the 'Parity' for the serial output link. Note that parity is often set to 'NONE'.
+</p>
+
+<p><a name="serdata"><h4>3.8.6 Data Bits - mandatory if 'Mountpoint' is set</h4></p>
+<p>
+Select the number of 'Data bits' for the serial output link. Note that often '8' data bits are used.
+</p>
+
+<p><a name="serstop"><h4>3.8.7 Stop Bits - mandatory if 'Mountpoint' is set</h4></p>
+<p>
+Select the number of 'Stop bits' for the serial output link. Note that often '1' stop bit is used.
+</p>
+
+<p><a name="serauto"><h4>3.8.8 NMEA - mandatory for VRS streams</h4></p>
+<p>
+Select 'Auto' to automatically forward all NMEA-GGA messages coming from your serial connected GNSS receiver to the NTRIP broadcaster and/or save them in a file.
+</p>
+<p>
+Forwarding valid NMEA-GGA messages to the NTRIP broadcaster is required for receiving 'Virtual Reference Station' (VRS) streams. Thus, in case your serial connected receiver is not capable to provide them, the alternative for VRS streams is a 'Manual' simulation of an initial NMEA-GGA message. Its contents is based on the approximate (editable) latitude/longitude from the broadcaster's source-table and an approximate VRS height to be specified.
+</p>
+<p>
+In summary: select 'Manual' only when handling a VRS stream and your serial connected GNSS receiver doesn't generate NMEA-GGA messages. Select 'Auto' otherweise.
+</p>
+
+<p><a name="serfile"><h4>3.8.9 File - optional if 'Auto' NMEA is set</h4></p>
+<p>Specify the full path to a file where NMEA messages coming from your serial connected receiver are saved.
+</p>
+<p><a name="serheight"><h4>3.8.10 Height - mandatory if 'Manual' NMEA is set</h4></p>
 <p>
 Specify an approximate 'Height' above mean sea level in meter for your VRS to simulate an inital NMEA-GGA message. Latitude and longitude for that (editable) are taken from the broadcaster's source-table.
@@ -885,5 +893,5 @@
 <li>Enter the IP address of the stream providing host.</li>
 <li>Enter the IP port number of the stream providing host.</li>
-<li>Specify a mountpoint. Recommended is a 4-character reference station ID. Example: FFMJ</li>
+<li>Specify a mountpoint. Recommended is a 4-character station ID. Example: FFMJ</li>
 <li>Specify the stream format. Available options are 'RTCM_2', 'RTCM_3', 'RTIGS', and 'ZERO'.</li>
 <li>Enter the approximate latitude of the stream providing rover in degrees. Example: 45.32.</li>
@@ -897,4 +905,38 @@
 Note that this option works only if no proxy server is involved in the communication link.
 </p>
+
+<p><a name="streamser"><h4>3.12.3 Add Streams - Coming from Serial Port</h4></p>
+<p>
+Button 'Add Streams' > 'Coming from Serial Port' allows to retrieve streams from a GNSS receiver via serial port without using the NTRIP transport protocol. For that you:
+<ul>
+<li>Specify a mountpoint. Recommended is a 4-character station ID. Example: FFMJ</li>
+<li>Specify the stream format. Available options are 'RTCM_2', 'RTCM_3', 'RTIGS', and 'ZERO'.</li>
+<li>Enter the approximate latitude of the stream providing receiver in degrees. Example: 45.32.</li>
+<li>Enter the approximate longitude of the stream providing receiver in degrees. Example: -15.20.</li>
+<li>Enter the serial 'Port name' selected on your host for communication with the receiver. Valid port names are
+<pre>
+Windows:       COM1, COM2
+Linux:         /dev/ttyS0, /dev/ttyS1
+FreeBSD:       /dev/ttyd0, /dev/ttyd1
+Digital Unix:  /dev/tty01, /dev/tty02
+HP-UX:         /dev/tty1p0, /dev/tty2p0
+SGI/IRIX:      /dev/ttyf1, /dev/ttyf2
+SunOS/Solaris: /dev/ttya, /dev/ttyb
+</pre>
+</li>
+<li>Select a 'Baud rate' for the serial input. Note that using a high baud rate is recommended.</li>
+<li>Select the number of 'Data bits' for the serial input. Note that often '8' data bits are used.</li>
+<li>Select the 'Parity' for the serial input. Note that parity is often set to 'NONE'.</li>
+<li>Select the number of 'Stop bits' for the serial input. Note that often '1' stop bit is used.</li>
+<li>Select a 'Flow control' for the serial link. Select 'OFF' if you don't know better.</li>
+</ul>
+</p>
+<p>
+When selecting the serial communication options listed above, make sure that you pick those configured to the serial connected GNSS receiver. 
+</p>
+
+<p>
+Streams received from a serial connected GNSS receiver show up with an 'S' (for <u>S</u>erial Port, no NTRIP) in the 'Streams' canvas section on BNC's main window . Latitude and longitude are to be entered just for informal reasons.
+<p>
 
 <p><a name="start"><h4>3.12.3 Start</h4></p>
@@ -1316,12 +1358,12 @@
 <tr><td>rnxV3=0</td><td>RINEX Observation: Version 3</td></tr>
 <tr><td>scanRTCM=0</td><td>Miscellaneous: Scan RTCM</td></tr>
-<tr><td>serialAutoNMEA=Auto</td><td>Serial Link: NMEA</td></tr>
-<tr><td>serialBaudRate=9600</td><td>Serial Link: Baud rate</td></tr>
-<tr><td>serialDataBits=8</td><td>Serial Link: Data bits</td></tr>
-<tr><td>serialHeightNMEA=</td><td>Serial Link: Height</td></tr>
-<tr><td>serialMountPoint=</td><td>Serial Link: Mountpoint</td></tr>
-<tr><td>serialParity=NONE</td><td>Serial Link: Parity</td></tr>
-<tr><td>serialPortName=</td><td>Serial Link: Port name</td></tr>
-<tr><td>serialStopBits=1</td><td>Serial Link: Stop bits</td></tr>
+<tr><td>serialAutoNMEA=Auto</td><td>Serial Output: NMEA</td></tr>
+<tr><td>serialBaudRate=9600</td><td>Serial Output: Baud rate</td></tr>
+<tr><td>serialDataBits=8</td><td>Serial Output: Data bits</td></tr>
+<tr><td>serialHeightNMEA=</td><td>Serial Output: Height</td></tr>
+<tr><td>serialMountPoint=</td><td>Serial Output: Mountpoint</td></tr>
+<tr><td>serialParity=NONE</td><td>Serial Output: Parity</td></tr>
+<tr><td>serialPortName=</td><td>Serial Output: Port name</td></tr>
+<tr><td>serialStopBits=1</td><td>Serial Output: Stop bits</td></tr>
 <tr><td>startTab=0</td><td>Internal memory: Top tab</td></tr>
 <tr><td>waitTime=5</td><td>Feed Engine: Wait for full epoch</td></tr>
Index: /trunk/BNC/bncserialport.cpp
===================================================================
--- /trunk/BNC/bncserialport.cpp	(revision 1745)
+++ /trunk/BNC/bncserialport.cpp	(revision 1746)
@@ -109,5 +109,5 @@
   editLayout->addWidget(new QLabel(tr("Longitude")),   1, 2, Qt::AlignRight);
   editLayout->addWidget(_serialLonLineEdit,            1, 3);
-  editLayout->addWidget(new QLabel(tr("Port")),        2, 0, Qt::AlignRight);
+  editLayout->addWidget(new QLabel(tr("Port name")),   2, 0, Qt::AlignRight);
   editLayout->addWidget(_serialPortLineEdit,           2, 1);
   editLayout->addWidget(new QLabel(tr("Baud rate")),   2, 2, Qt::AlignRight);
Index: /trunk/BNC/bncwindow.cpp
===================================================================
--- /trunk/BNC/bncwindow.cpp	(revision 1745)
+++ /trunk/BNC/bncwindow.cpp	(revision 1746)
@@ -211,6 +211,6 @@
   _outUPortLineEdit   = new QLineEdit(settings.value("outUPort").toString());
 
-  // Serial Link Options
-  // -------------------
+  // Serial Output Options
+  // ---------------------
   _serialMountPointLineEdit = new QLineEdit(settings.value("serialMountPoint").toString());
   _serialPortNameLineEdit = new QLineEdit(settings.value("serialPortName").toString());
@@ -353,13 +353,13 @@
   _miscMountLineEdit->setWhatsThis(tr("<p>Specify a mountpoint to apply any of the options shown below. Enter 'ALL' if you want to apply these options to all configured streams.</p><p>An empty option field (default) means that you don't want BNC to apply any of these options.</p>"));
   _scanRTCMCheckBox->setWhatsThis(tr("<p>Tick 'Scan RTCM' to log the numbers of incomming message types as well as contained antenna coordinates, antenna heigt, and antenna descriptor.</p>"));
-  _serialMountPointLineEdit->setWhatsThis(tr("<p>Enter a 'Mountpoint' to forward the corresponding stream to a serial connected device.</p>"));
-  _serialPortNameLineEdit->setWhatsThis(tr("<p>Enter the serial 'Port name' selected for communication with your serial connected device. Valid port names are</p><pre>Windows:       COM1, COM2<br>Linux:         /dev/ttyS0, /dev/ttyS1<br>FreeBSD:       /dev/ttyd0, /dev/ttyd1<br>Digital Unix:  /dev/tty01, /dev/tty02<br>HP-UX:         /dev/tty1p0, /dev/tty2p0<br>SGI/IRIX:      /dev/ttyf1, /dev/ttyf2<br>SunOS/Solaris: /dev/ttya, /dev/ttyb</pre><p>Note that you must plug a serial cable in the port defined here before you start BNC.</p>"));
-  _serialBaudRateComboBox->setWhatsThis(tr("<p>Select a 'Baud rate' for the serial link.</p><p>Note that your selection must equal the baud rate configured to the serial connected device. Note further that using a high baud rate is recommended.</p>"));
-  _serialParityComboBox->setWhatsThis(tr("<p>Select the 'Parity' for the serial link.</p><p>Note that your selection must equal the parity selection configured to the serial connected device. Note further that parity is often set to 'NONE'.</p>"));
-  _serialDataBitsComboBox->setWhatsThis(tr("<p>Select the number of 'Data bits' for the serial link.</p><p>Note that your selection must equal the number of data bits configured to the serial connected device. Note further that often 8 data bits are used.</p>"));
-  _serialStopBitsComboBox->setWhatsThis(tr("<p>Select the number of 'Stop bits' for the serial link.</p><p>Note that your selection must equal the number of stop bits configured to the serial connected device. Note further that often 1 stop bit is used.</p>"));
-  _serialFlowControlComboBox->setWhatsThis(tr("<p>Select a 'Flow control' for the serial link.</p><p>Note that your selection must equal the flow control configured to the serial connected device. Select 'OFF' if you don't know better.</p>"));
-  _serialAutoNMEAComboBox->setWhatsThis(tr("<p>Select 'Auto' to automatically forward NMEA-GGA messages coming from your serial connected device to the NTRIP broadcaster and/or save them in a file.</p><p>Select 'Manual' only when handling a VRS stream and your serial connected device doesn't generate NMEA-GGA messages.</p>"));
-  _serialFileNMEALineEdit->setWhatsThis(tr("<p>Specify the full path to a file where NMEA messages coming from your serial connected device are saved.</p>"));
+  _serialMountPointLineEdit->setWhatsThis(tr("<p>Enter a 'Mountpoint' to forward the corresponding stream to a serial connected receiver.</p>"));
+  _serialPortNameLineEdit->setWhatsThis(tr("<p>Enter the serial 'Port name' selected for communication with your serial connected receiver. Valid port names are</p><pre>Windows:       COM1, COM2<br>Linux:         /dev/ttyS0, /dev/ttyS1<br>FreeBSD:       /dev/ttyd0, /dev/ttyd1<br>Digital Unix:  /dev/tty01, /dev/tty02<br>HP-UX:         /dev/tty1p0, /dev/tty2p0<br>SGI/IRIX:      /dev/ttyf1, /dev/ttyf2<br>SunOS/Solaris: /dev/ttya, /dev/ttyb</pre><p>Note that you must plug a serial cable in the port defined here before you start BNC.</p>"));
+  _serialBaudRateComboBox->setWhatsThis(tr("<p>Select a 'Baud rate' for the serial output link.</p><p>Note that your selection must equal the baud rate configured to the serial connected receiver. Note further that using a high baud rate is recommended.</p>"));
+  _serialParityComboBox->setWhatsThis(tr("<p>Select the 'Parity' for the serial output link.</p><p>Note that your selection must equal the parity selection configured to the serial connected receiver. Note further that parity is often set to 'NONE'.</p>"));
+  _serialDataBitsComboBox->setWhatsThis(tr("<p>Select the number of 'Data bits' for the serial output link.</p><p>Note that your selection must equal the number of data bits configured to the serial connected receiver. Note further that often 8 data bits are used.</p>"));
+  _serialStopBitsComboBox->setWhatsThis(tr("<p>Select the number of 'Stop bits' for the serial output link.</p><p>Note that your selection must equal the number of stop bits configured to the serial connected receiver. Note further that often 1 stop bit is used.</p>"));
+  _serialFlowControlComboBox->setWhatsThis(tr("<p>Select a 'Flow control' for the serial output link.</p><p>Note that your selection must equal the flow control configured to the serial connected receiver. Select 'OFF' if you don't know better.</p>"));
+  _serialAutoNMEAComboBox->setWhatsThis(tr("<p>Select 'Auto' to automatically forward NMEA-GGA messages coming from your serial connected receiver to the NTRIP broadcaster and/or save them in a file.</p><p>Select 'Manual' only when handling a VRS stream and your serial connected receiver doesn't generate NMEA-GGA messages.</p>"));
+  _serialFileNMEALineEdit->setWhatsThis(tr("<p>Specify the full path to a file where NMEA messages coming from your serial connected receiver are saved.</p>"));
   _serialHeightNMEALineEdit->setWhatsThis(tr("<p>Specify an approximate 'Height' above mean sea level in meter for your VRS to simulate an inital NMEA-GGA message.</p><p>The setting of this option is ignored in case of streams coming from physical reference stations.</p>"));
 
@@ -385,5 +385,5 @@
   aogroup->addTab(cgroup,tr("Broadcast Corrections"));
   aogroup->addTab(sgroup,tr("Feed Engine"));
-  aogroup->addTab(sergroup,tr("Serial Link"));
+  aogroup->addTab(sergroup,tr("Serial Output"));
   aogroup->addTab(agroup,tr("Outages"));
   aogroup->addTab(rgroup,tr("Miscellaneous"));
@@ -573,6 +573,6 @@
   }
 
-  // Serial Link
-  // -----------
+  // Serial Output
+  // -------------
   QGridLayout* serLayout = new QGridLayout;
   serLayout->setColumnMinimumWidth(0,14*ww);
@@ -605,5 +605,5 @@
   serLayout->addWidget(new QLabel("Height"),                      4,20, Qt::AlignRight);
   serLayout->addWidget(_serialHeightNMEALineEdit,                 4,21,1,11);
-  serLayout->addWidget(new QLabel("Serial port settings to feed a serial connected device."),5,0,1,30);
+  serLayout->addWidget(new QLabel("Serial port settings to feed a serial connected receiver."),5,0,1,30);
 
   connect(_serialMountPointLineEdit, SIGNAL(textChanged(const QString &)),
@@ -1415,6 +1415,6 @@
   }
 
-  // Serial Link
-  // -----------
+  // Serial Output
+  // -------------
   if (aogroup->currentIndex() == 6) {
     if (!isEmpty) {