Index: /trunk/BNS/bnshelp.html
===================================================================
--- /trunk/BNS/bnshelp.html	(revision 1804)
+++ /trunk/BNS/bnshelp.html	(revision 1805)
@@ -679,4 +679,9 @@
 <tr><td>outFile_3=/home/weber/rinex/CLCK3</td><td>Broadcast Corrections III: Save (full path)</td></tr>
 <tr><td>beClocks3=0</td><td>Broadcast Corrections III: Broadcast clocks</td></tr>
+<tr><td>outHostEph=www.igs-ip.net</td><td>Broadcast Ephemeris: Host</td></tr>
+<tr><td>outPortEph=2101</td><td>Broadcast Ephemeris: Port</td></tr>
+<tr><td>mountpoint_Eph=BRDC0</td><td>Broadcast Ephemeris: Mountpoint</td></tr>
+<tr><td>passwordEph=pass</td><td>Broadcast Ephemeris: Password</td></tr>
+<tr><td>samplEph=5</td><td>Broadcast Ephemeris: Sampling</td></tr>
 <tr><td>trafo_dx=0.0541</td><td>Broadcast Corrections: System > Custom</td></tr>
 <tr><td>trafo_dy=0.0502</td><td>Broadcast Corrections: System > Custom</td></tr>
Index: /trunk/BNS/bnssettings.cpp
===================================================================
--- /trunk/BNS/bnssettings.cpp	(revision 1804)
+++ /trunk/BNS/bnssettings.cpp	(revision 1805)
@@ -66,4 +66,5 @@
     setValue("mountpoint_Eph","");
     setValue("passwordEph",   "");
+    setValue("samplEph",      "5");
 
     setValue("trafo_dx",    "0.0541");
Index: /trunk/BNS/bnswindow.cpp
===================================================================
--- /trunk/BNS/bnswindow.cpp	(revision 1804)
+++ /trunk/BNS/bnswindow.cpp	(revision 1805)
@@ -231,4 +231,11 @@
   _password_Eph_LineEdit->setEchoMode(QLineEdit::Password);
   _mountpoint_Eph_LineEdit = new QLineEdit(settings.value("mountpoint_Eph").toString());
+  _samplEphSpinBox = new QSpinBox;
+  _samplEphSpinBox->setMinimum(0);
+  _samplEphSpinBox->setMaximum(60);
+  _samplEphSpinBox->setSingleStep(5);
+  _samplEphSpinBox->setMaximumWidth(9*ww);
+  _samplEphSpinBox->setValue(settings.value("samplEph").toInt());
+  _samplEphSpinBox->setSuffix(" sec");
 
   // RINEX Clocks Options
@@ -301,4 +308,5 @@
   _mountpoint_Eph_LineEdit->setWhatsThis(tr("Specify the mounpoint for stream upload to an NTRIP Broadcaster."));
   _password_Eph_LineEdit->setWhatsThis(tr("Specify the stream upload password protecting the mounpoint on an NTRIP Broadcaster."));
+  _samplEphSpinBox->setWhatsThis(tr("Select the Broadcast Ephemeris sampling interval in seconds. Defaut is '5' meaning that a complete set of Broadcast Ephemeris is uploaded every 5 seconds."));
   _rnxPathLineEdit->setWhatsThis(tr("Specify the path for saving the generated clock corrections as Clock RINEX files. If the specified directory does not exist, BNS will not create Clock RINEX files."));
   _rnxIntrComboBox->setWhatsThis(tr("Select the length of the Clock RINEX file."));
@@ -594,6 +602,7 @@
   layout_casEph->addWidget(new QLabel("          Password"),    1, 2, Qt::AlignRight);
   layout_casEph->addWidget(_password_Eph_LineEdit,              1, 3);
-  layout_casEph->addWidget(new QLabel("Upload concatenated Broadcast Ephemeris in RTCMv3 format to caster."), 2, 0, 1, 50);
-  layout_casEph->addWidget(new QLabel(""),                      3, 0);
+  layout_casEph->addWidget(new QLabel("Sampling"),              2, 0);
+  layout_casEph->addWidget(_samplEphSpinBox,                    2, 1);
+  layout_casEph->addWidget(new QLabel("Upload concatenated RTCMv3 Broadcast Ephemeris caster."), 3, 0, 1, 50);
 
   tab_casEph->setLayout(layout_casEph);
@@ -604,7 +613,9 @@
     _mountpoint_Eph_LineEdit->setStyleSheet("background-color: lightGray");
     _password_Eph_LineEdit->setStyleSheet("background-color: lightGray");
+    _samplEphSpinBox->setStyleSheet("background-color: lightGray");
     _outPort_Eph_LineEdit->setEnabled(false);
     _mountpoint_Eph_LineEdit->setEnabled(false);
     _password_Eph_LineEdit->setEnabled(false);
+    _samplEphSpinBox->setEnabled(false);
   }
 
@@ -877,4 +888,5 @@
   settings.setValue("mountpoint_Eph",_mountpoint_Eph_LineEdit->text());
   settings.setValue("passwordEph",   _password_Eph_LineEdit->text());
+  settings.setValue("samplEph",      _samplEphSpinBox->value());
 
   settings.setValue("rnxPath",     _rnxPathLineEdit->text());
@@ -1152,14 +1164,18 @@
       _mountpoint_Eph_LineEdit->setStyleSheet("background-color: white");
       _password_Eph_LineEdit->setStyleSheet("background-color: white");
+      _samplEphSpinBox->setStyleSheet("background-color: white");
       _outPort_Eph_LineEdit->setEnabled(true);
       _mountpoint_Eph_LineEdit->setEnabled(true);
       _password_Eph_LineEdit->setEnabled(true);
+      _samplEphSpinBox->setEnabled(true);
     } else {
       _outPort_Eph_LineEdit->setStyleSheet("background-color: lightGray");
       _mountpoint_Eph_LineEdit->setStyleSheet("background-color: lightGray");
       _password_Eph_LineEdit->setStyleSheet("background-color: lightGray");
+      _samplEphSpinBox->setStyleSheet("background-color: lightGray");
       _outPort_Eph_LineEdit->setEnabled(false);
       _mountpoint_Eph_LineEdit->setEnabled(false);
       _password_Eph_LineEdit->setEnabled(false);
+      _samplEphSpinBox->setEnabled(false);
     }
   }
Index: /trunk/BNS/bnswindow.h
===================================================================
--- /trunk/BNS/bnswindow.h	(revision 1804)
+++ /trunk/BNS/bnswindow.h	(revision 1805)
@@ -118,4 +118,5 @@
   QLineEdit* _mountpoint_Eph_LineEdit;
   QLineEdit* _password_Eph_LineEdit;
+  QSpinBox*  _samplEphSpinBox;
 
   QLineEdit* _rnxPathLineEdit;