Index: /trunk/ntripclient/ntripclient.c
===================================================================
--- /trunk/ntripclient/ntripclient.c	(revision 1810)
+++ /trunk/ntripclient/ntripclient.c	(revision 1811)
@@ -1,5 +1,5 @@
 /*
   NTRIP client for POSIX.
-  $Id: ntripclient.c,v 1.46 2008/11/04 15:35:03 stoecker Exp $
+  $Id: ntripclient.c,v 1.47 2009/02/10 12:18:23 stoecker Exp $
   Copyright (C) 2003-2008 by Dirk Stöcker <soft@dstoecker.de>
 
@@ -65,6 +65,6 @@
 
 /* CVS revision and version */
-static char revisionstr[] = "$Revision: 1.46 $";
-static char datestr[]     = "$Date: 2008/11/04 15:35:03 $";
+static char revisionstr[] = "$Revision: 1.47 $";
+static char datestr[]     = "$Date: 2009/02/10 12:18:23 $";
 
 enum MODE { HTTP = 1, RTSP = 2, NTRIP1 = 3, AUTO = 4, UDP = 5, END };
@@ -706,5 +706,6 @@
         if(args.mode == UDP)
         {
-          int session, tim, seq, init;
+          unsigned int session;
+          int tim, seq, init;
           char rtpbuf[1526];
           int i=12, j;
@@ -875,5 +876,6 @@
                     {
                       time_t ct;
-                      int u,v,w;
+                      int u,v;
+                      unsigned int w;
                       u = ((unsigned char)rtpbuf[2]<<8)+(unsigned char)rtpbuf[3];
                       v = ((unsigned char)rtpbuf[4]<<24)+((unsigned char)rtpbuf[5]<<16)
@@ -1145,5 +1147,5 @@
                 "PLAY rtsp://%s%s%s/%s RTSP/1.0\r\n"
                 "CSeq: %d\r\n"
-                "Session: %d\r\n"
+                "Session: %u\r\n"
                 "\r\n",
                 args.server, proxyserver ? ":" : "", proxyserver ? args.port : "",
@@ -1239,5 +1241,5 @@
                             "GET_PARAMETER rtsp://%s%s%s/%s RTSP/1.0\r\n"
                             "CSeq: %d\r\n"
-                            "Session: %d\r\n"
+                            "Session: %u\r\n"
                             "\r\n",
                             args.server, proxyserver ? ":" : "", proxyserver
@@ -1290,5 +1292,5 @@
                   "TEARDOWN rtsp://%s%s%s/%s RTSP/1.0\r\n"
                   "CSeq: %d\r\n"
-                  "Session: %d\r\n"
+                  "Session: %u\r\n"
                   "\r\n",
                   args.server, proxyserver ? ":" : "", proxyserver ? args.port : "",
Index: /trunk/ntripserver/ntripserver.c
===================================================================
--- /trunk/ntripserver/ntripserver.c	(revision 1810)
+++ /trunk/ntripserver/ntripserver.c	(revision 1811)
@@ -1,4 +1,4 @@
 /*
- * $Id: ntripserver.c,v 1.46 2009/02/10 12:20:09 stoecker Exp $
+ * $Id: ntripserver.c,v 1.47 2009/02/11 10:20:32 stoecker Exp $
  *
  * Copyright (c) 2003...2007
@@ -37,6 +37,6 @@
 
 /* CVS revision and version */
-static char revisionstr[] = "$Revision: 1.46 $";
-static char datestr[]     = "$Date: 2009/02/10 12:20:09 $";
+static char revisionstr[] = "$Revision: 1.47 $";
+static char datestr[]     = "$Date: 2009/02/11 10:20:32 $";
 
 #include <ctype.h>
@@ -136,5 +136,5 @@
 /* Forward references */
 static void send_receive_loop(sockettype sock, int outmode,
-  struct sockaddr * pcasterRTP, socklen_t length, int rtpssrc);
+  struct sockaddr * pcasterRTP, socklen_t length, unsigned int rtpssrc);
 static void usage(int, char *);
 static int  encode(char *buf, int size, const char *user, const char *pwd);
@@ -220,5 +220,5 @@
   int                client_port = 0;
   int                server_port = 0;
-  int                session = 0;
+  unsigned int       session = 0;
   socklen_t          len = 0;
   int                i = 0;
@@ -933,5 +933,5 @@
         case UDP:
           {
-            int session;
+            unsigned int session;
             char rtpbuf[1526];
             int i=12, j;
@@ -1317,5 +1317,5 @@
                 "RECORD rtsp://%s%s/%s RTSP/1.0\r\n"
                 "CSeq: %d\r\n"
-                "Session: %d\r\n"
+                "Session: %u\r\n"
                 "\r\n",
                 casterouthost, rtsp_extension,  mountpoint,  udp_cseq++,
@@ -1374,5 +1374,5 @@
 
 static void send_receive_loop(sockettype sock, int outmode, struct sockaddr* pcasterRTP,
-socklen_t length, int rtpssrc)
+socklen_t length, unsigned int rtpssrc)
 {
   int      nodata = 0;
@@ -1579,5 +1579,5 @@
       i = recv(socket_tcp, rtpbuf, sizeof(rtpbuf), 0);
       if(i >= 12 && (unsigned char)rtpbuf[0] == (2 << 6) && rtpssrc ==
-      (((unsigned char)rtpbuf[8]<<24)+((unsigned char)rtpbuf[9]<<16)
+      (unsigned int)(((unsigned char)rtpbuf[8]<<24)+((unsigned char)rtpbuf[9]<<16)
       +((unsigned char)rtpbuf[10]<<8)+(unsigned char)rtpbuf[11]))
       {
@@ -1694,5 +1694,5 @@
         "GET_PARAMETER rtsp://%s%s/%s RTSP/1.0\r\n"
         "CSeq: %d\r\n"
-        "Session: %d\r\n"
+        "Session: %u\r\n"
         "\r\n",
         casterouthost, rtsp_extension,  mountpoint,  udp_cseq++, rtpssrc);
@@ -2282,5 +2282,5 @@
         "TEARDOWN rtsp://%s%s/%s RTSP/1.0\r\n"
         "CSeq: %d\r\n"
-        "Session: %d\r\n"
+        "Session: %u\r\n"
         "\r\n",
         caster_addr, rtsp_ext, mountpoint, udp_cseq++, session);